﻿@namespace ServiceDesk.Presentation.Components.Mantenimientos

@using System.Collections.ObjectModel
@using System.Collections;
@using Microsoft.AspNetCore.Components.Authorization

@inject SlaAgent slaAgent

<TelerikGrid Data=@GridData EditMode="@GridEditMode.Popup"
             Pageable="true" PageSize=25
             OnUpdate=@UpdateItem OnDelete=@DeleteItem OnCreate=@CreateItem>
    <GridToolBar>
        <GridCommandButton Command="Add" Icon="add">Agregar Sla</GridCommandButton>
    </GridToolBar>
    <GridColumns>
        <GridColumn Field=@nameof(SlaDto.Descripcion) Editable="true" />
        <GridColumn Field=@nameof(SlaDto.CantidadHoras) Editable="true" />
        <GridColumn Field=@nameof(SlaDto.CreadoPor) Editable="false" Title="Creado Por" />
        <GridColumn Field=@nameof(SlaDto.FechaRegistro) Editable="false" DisplayFormat="{0:dd/MM/yyyy hh:mm tt}" Title="Fecha de Registro" />
        <GridColumn Field=@nameof(SlaDto.FechaModificacion) Editable="false" DisplayFormat="{0:dd/MM/yyyy hh:mm tt}" Title="Fecha de Modificación" />
        <GridCommandColumn Width="120px">
            <GridCommandButton Command="Edit" Icon="edit"></GridCommandButton>
            <GridCommandButton Command="Delete" Icon="delete"></GridCommandButton>
        </GridCommandColumn>
    </GridColumns>
</TelerikGrid>

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationState { get; set; }

    [CascadingParameter]
    private DialogFactory Dialog { get; set; }

    public List<SlaDto> GridData { get; set; } = new List<SlaDto>();

    protected override async Task OnInitializedAsync()
    {
        try
        {
            Timer timer = new Timer();
            timer.Interval = 5000;
            timer.Elapsed += timer_elapsed;
            await LoadData();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }

    private async void timer_elapsed(object sender, ElapsedEventArgs e)
    {
        await LoadData();
    }

    private async Task LoadData()
    {
        try
        {
            GridData = await slaAgent.Get();
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }

    private async void CreateItem(GridCommandEventArgs args)
    {
        try
        {
            SlaDto sla = args.Item as SlaDto;
            sla.Borrado = false;
            sla.CreadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            sla.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            await slaAgent.Add(sla);
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }
    }

    private async void DeleteItem(GridCommandEventArgs args)
    {
        SlaDto sla = args.Item as SlaDto;
        try
        {
            if (await Dialog.ConfirmAsync("¿Está seguro que desea borrar este registro?"))
            {

            }
            await slaAgent.Remove(sla.Id);
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }
        StateHasChanged();
    }

    private async void UpdateItem(GridCommandEventArgs args)
    {
        try
        {
            SlaDto sla = args.Item as SlaDto;
            sla.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            await slaAgent.Edit(sla);
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }
}